# 0915CXH_DL_SA

## 文件目录
```bash
0915CXH_DL_SA                       主目录  
├── Data                            数据  
│   ├── 3025.npy                    npy格式的数据  
│   ├── 3026.txt                    txt格式的数据  
│   ├── .......                   
│   └── 3033.npy                    
├── Output                          存放暂停发生起止时间 
│   └── 3025.csv                  
├── SADetectModel                   存放模型结构文件和训练好的模型 
│   ├── SaDetectModel.py            模型结构文件    
│   └── SAmodel0.pt                 模型权重文件    
├── utils                           基本库
│   ├── SignalPreprocess.py         心晓数据预处理
│   ├── ModelDetection.py           模型检测
│   └── ResultSummary.py            片段结果后处理    
├── ApneaDetection.py               启动入口  
└── README.md                       项目说明

```


## 开发环境
实际运行环境可以不用严格按照下面的环境配置，只要能运行即可。
- numpy==1.20.3
- pandas==1.3.3
- tqdm==4.64.0
- scipy==1.7.3
- torch==1.11.0+cu113
- torchvision==0.12.0+cu113
- torchaudio==0.11.0+cu113

## 使用方法

### 1. 从PyCharm中运行
从0915CXH_DL_SA文件夹中打开PyCharm，  
打开**Main_Quality_Relabel**.py  
修改  
```bash
option.data_path      # 数据或文件夹路径
option.hz             # 采样频率 默认为1000Hz
option.model          # 模型选择 仅支持0、1、3、4
option.batch_size     # 批处理大小 默认为4096
option.output         # 输出文件夹路径
option.TST            # 真实睡眠时长，仅支持单文件输入，留空则以数据长度为真实睡眠时长
```





### 2. 从命令行运行
**注意：命令行传入变量优先级低于程序内设置的变量**  
从命令行中传入参数，无需打开pycharm，直接在代码文件夹的路径栏输入cmd后回车，进入到命令提示符
，再在命令提示符中运行python 程序名 参数 即可运行

#### 支持参数

```bash
usage: ApneaDetection.py [-h] 
                         [-d [DATA_PATH]]
                         [-n [FREQUENCY]]
                         [-m [MODEL_NUMBER]]
                         [-b [BATCH_SIZE]]
                         [-o [OUTPUT_PATH]]
                         [-t [TST]]


optional arguments:
  -h, --help            
                        显示帮助信息
  -d [DATA_PATH], --data_path [DATA_PATH]
                        数据文件或文件夹路径
  -n [FREQUENCY], --frequency [FREQUENCY]
                        采样频率 默认为1000Hz
  -m [MODEL_NUMBER], --model_number [MODEL_NUMBER]
                        模型选择 仅支持0、1、3、4
  -b [BATCH_SIZE], --batch_size [BATCH_SIZE]
                        批处理大小 默认为4096   
  -o [OUTPUT_PATH], --output_path [OUTPUT_PATH]
                        输出文件夹路径 
  -t [TST], --TST [TST] 
                        真实睡眠时长，仅支持单文件输入，留空则以数据长度为真实睡眠时长 

```



